/*
 * Ported from Flashlight VNC ActionScript implementation:
 *     http://www.wizhelp.com/flashlight-vnc/
 *
 * Full attribution follows:
 *
 * -------------------------------------------------------------------------
 *
 * This DES class has been extracted from package Acme.Crypto for use in VNC.
 * The unnecessary odd parity code has been removed.
 *
 * These changes are:
 *  Copyright (C) 1999 AT&T Laboratories Cambridge.  All Rights Reserved.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *

 * DesCipher - the DES encryption method
 *
 * The meat of this code is by Dave Zimmerman <dzimm@widget.com>, and is:
 *
 * Copyright (c) 1996 Widget Workshop, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL or COMMERCIAL purposes and
 * without fee is hereby granted, provided that this copyright notice is kept 
 * intact. 
 * 
 * WIDGET WORKSHOP MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
 * OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. WIDGET WORKSHOP SHALL NOT BE LIABLE
 * FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  WIDGET WORKSHOP
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 *
 *
 * The rest is:
 *
 * Copyright (C) 1996 by Jef Poskanzer <jef@acme.com>.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the ACME Labs Java page for up-to-date versions of this and other
 * fine Java utilities: http://www.acme.com/java/
 */
"use strict";function DES(e){function t(e){var t,n,o,i,a,s,l,r,u,c,d=[],h=[],p=[];for(n=0,o=56;56>n;++n,o-=8)o+=-5>o?65:-3>o?31:-1>o?63:27===o?35:0,i=7&o,d[n]=0!==(e[o>>>3]&1<<i)?1:0;for(t=0;16>t;++t){for(i=t<<1,a=i+1,p[i]=p[a]=0,s=28;59>s;s+=28)for(n=s-28;s>n;++n)o=n+y[t],h[n]=s>o?d[o]:d[o-28];for(n=0;24>n;++n)0!==h[b[n]]&&(p[i]|=1<<23-n),0!==h[b[n+24]]&&(p[a]|=1<<23-n)}for(t=0,u=0,c=0;16>t;++t)l=p[u++],r=p[u++],A[c]=(16515072&l)<<6,A[c]|=(4032&l)<<10,A[c]|=(16515072&r)>>>10,A[c]|=(4032&r)>>>6,++c,A[c]=(258048&l)<<12,A[c]|=(63&l)<<16,A[c]|=(258048&r)>>>4,A[c]|=63&r,++c}function n(e){var t,n,o,i,a=0,s=e.slice(),l=0;for(n=s[a++]<<24|s[a++]<<16|s[a++]<<8|s[a++],o=s[a++]<<24|s[a++]<<16|s[a++]<<8|s[a++],i=252645135&(n>>>4^o),o^=i,n^=i<<4,i=65535&(n>>>16^o),o^=i,n^=i<<16,i=858993459&(o>>>2^n),n^=i,o^=i<<2,i=16711935&(o>>>8^n),n^=i,o^=i<<8,o=o<<1|1&o>>>31,i=2863311530&(n^o),n^=i,o^=i,n=n<<1|1&n>>>31,a=0;8>a;++a)i=o<<28|o>>>4,i^=A[l++],t=g[63&i],t|=m[63&i>>>8],t|=h[63&i>>>16],t|=c[63&i>>>24],i=o^A[l++],t|=v[63&i],t|=f[63&i>>>8],t|=p[63&i>>>16],t|=d[63&i>>>24],n^=t,i=n<<28|n>>>4,i^=A[l++],t=g[63&i],t|=m[63&i>>>8],t|=h[63&i>>>16],t|=c[63&i>>>24],i=n^A[l++],t|=v[63&i],t|=f[63&i>>>8],t|=p[63&i>>>16],t|=d[63&i>>>24],o^=t;for(o=o<<31|o>>>1,i=2863311530&(n^o),n^=i,o^=i,n=n<<31|n>>>1,i=16711935&(n>>>8^o),o^=i,n^=i<<8,i=858993459&(n>>>2^o),o^=i,n^=i<<2,i=65535&(o>>>16^n),n^=i,o^=i<<16,i=252645135&(o>>>4^n),n^=i,o^=i<<4,i=[o,n],a=0;8>a;a++)s[a]=(i[a>>>2]>>>8*(3-a%4))%256,s[a]<0&&(s[a]+=256);return s}function o(e){return n(e.slice(0,8)).concat(n(e.slice(8,16)))}var i,a,s,l,r,u,c,d,h,p,m,f,g,v,b=[13,16,10,23,0,4,2,27,14,5,20,9,22,18,11,3,25,7,15,6,26,19,12,1,40,51,30,36,46,54,29,39,50,44,32,47,43,48,38,55,33,52,45,41,49,35,28,31],y=[1,2,4,6,8,10,12,14,15,17,19,21,23,25,27,28],w=0,A=[];return i=65536,a=1<<24,s=i|a,l=4,r=1024,u=l|r,c=[s|r,w|w,i|w,s|u,s|l,i|u,w|l,i|w,w|r,s|r,s|u,w|r,a|u,s|l,a|w,w|l,w|u,a|r,a|r,i|r,i|r,s|w,s|w,a|u,i|l,a|l,a|l,i|l,w|w,w|u,i|u,a|w,i|w,s|u,w|l,s|w,s|r,a|w,a|w,w|r,s|l,i|w,i|r,a|l,w|r,w|l,a|u,i|u,s|u,i|l,s|w,a|u,a|l,w|u,i|u,s|r,w|u,a|r,a|r,w|w,i|l,i|r,w|w,s|l],i=1<<20,a=1<<31,s=i|a,l=32,r=32768,u=l|r,d=[s|u,a|r,w|r,i|u,i|w,w|l,s|l,a|u,a|l,s|u,s|r,a|w,a|r,i|w,w|l,s|l,i|r,i|l,a|u,w|w,a|w,w|r,i|u,s|w,i|l,a|l,w|w,i|r,w|u,s|r,s|w,w|u,w|w,i|u,s|l,i|w,a|u,s|w,s|r,w|r,s|w,a|r,w|l,s|u,i|u,w|l,w|r,a|w,w|u,s|r,i|w,a|l,i|l,a|u,a|l,i|l,i|r,w|w,a|r,w|u,a|w,s|l,s|u,i|r],i=1<<17,a=1<<27,s=i|a,l=8,r=512,u=l|r,h=[w|u,s|r,w|w,s|l,a|r,w|w,i|u,a|r,i|l,a|l,a|l,i|w,s|u,i|l,s|w,w|u,a|w,w|l,s|r,w|r,i|r,s|w,s|l,i|u,a|u,i|r,i|w,a|u,w|l,s|u,w|r,a|w,s|r,a|w,i|l,w|u,i|w,s|r,a|r,w|w,w|r,i|l,s|u,a|r,a|l,w|r,w|w,s|l,a|u,i|w,a|w,s|u,w|l,i|u,i|r,a|l,s|w,a|u,w|u,s|w,i|u,w|l,s|l,i|r],i=8192,a=1<<23,s=i|a,l=1,r=128,u=l|r,p=[s|l,i|u,i|u,w|r,s|r,a|u,a|l,i|l,w|w,s|w,s|w,s|u,w|u,w|w,a|r,a|l,w|l,i|w,a|w,s|l,w|r,a|w,i|l,i|r,a|u,w|l,i|r,a|r,i|w,s|r,s|u,w|u,a|r,a|l,s|w,s|u,w|u,w|w,w|w,s|w,i|r,a|r,a|u,w|l,s|l,i|u,i|u,w|r,s|u,w|u,w|l,i|w,a|l,i|l,s|r,a|u,i|l,i|r,a|w,s|l,w|r,a|w,i|w,s|r],i=1<<25,a=1<<30,s=i|a,l=256,r=1<<19,u=l|r,m=[w|l,i|u,i|r,s|l,w|r,w|l,a|w,i|r,a|u,w|r,i|l,a|u,s|l,s|r,w|u,a|w,i|w,a|r,a|r,w|w,a|l,s|u,s|u,i|l,s|r,a|l,w|w,s|w,i|u,i|w,s|w,w|u,w|r,s|l,w|l,i|w,a|w,i|r,s|l,a|u,i|l,a|w,s|r,i|u,a|u,w|l,i|w,s|r,s|u,w|u,s|w,s|u,i|r,w|w,a|r,s|w,w|u,i|l,a|l,w|r,w|w,a|r,i|u,a|l],i=1<<22,a=1<<29,s=i|a,l=16,r=16384,u=l|r,f=[a|l,s|w,w|r,s|u,s|w,w|l,s|u,i|w,a|r,i|u,i|w,a|l,i|l,a|r,a|w,w|u,w|w,i|l,a|u,w|r,i|r,a|u,w|l,s|l,s|l,w|w,i|u,s|r,w|u,i|r,s|r,a|w,a|r,w|l,s|l,i|r,s|u,i|w,w|u,a|l,i|w,a|r,a|w,w|u,a|l,s|u,i|r,s|w,i|u,s|r,w|w,s|l,w|l,w|r,s|w,i|u,w|r,i|l,a|u,w|w,s|r,a|w,i|l,a|u],i=1<<21,a=1<<26,s=i|a,l=2,r=2048,u=l|r,g=[i|w,s|l,a|u,w|w,w|r,a|u,i|u,s|r,s|u,i|w,w|w,a|l,w|l,a|w,s|l,w|u,a|r,i|u,i|l,a|r,a|l,s|w,s|r,i|l,s|w,w|r,w|u,s|u,i|r,w|l,a|w,i|r,a|w,i|r,i|w,a|u,a|u,s|l,s|l,w|l,i|l,a|w,a|r,i|w,s|r,w|u,i|u,s|r,w|u,a|l,s|u,s|w,i|r,w|w,w|l,s|u,w|w,i|u,s|w,w|r,a|l,a|r,w|r,i|l],i=1<<18,a=1<<28,s=i|a,l=64,r=4096,u=l|r,v=[a|u,w|r,i|w,s|u,a|w,a|u,w|l,a|w,i|l,s|w,s|u,i|r,s|r,i|u,w|r,w|l,s|w,a|l,a|r,w|u,i|r,i|l,s|l,s|r,w|u,w|w,w|w,s|l,a|l,a|r,i|u,i|w,i|u,i|w,s|r,w|r,w|l,s|l,w|r,i|u,a|r,w|l,a|l,s|w,s|l,a|w,i|w,a|u,w|w,s|u,i|l,a|l,s|w,a|r,a|u,w|w,s|u,i|r,i|r,w|u,w|u,i|l,a|w,s|r],t(e),{encrypt:o}}