/*
 * Websock: high-performance binary WebSockets
 * Copyright (C) 2011 Joel Martin
 * Licensed under LGPL-3 (see LICENSE.txt)
 *
 * Websock is similar to the standard WebSocket object but Websock
 * enables communication with raw TCP sockets (i.e. the binary stream)
 * via websockify. This is accomplished by base64 encoding the data
 * stream between Websock and websockify.
 *
 * Websock has built-in receive queue buffering; the message event
 * does not contain actual data but is simply a notification that
 * there is new data available. Several rQ* methods are available to
 * read binary data off of the receive queue.
 */
function Websock(){"use strict";function e(){return T}function t(){return x}function n(){return P}function o(e){P=e}function i(){return x.length-P}function a(){return x[P]}function s(){return x[P++]}function r(e){0===P?x.unshift(e):(P-=1,x[P]=e)}function l(){return(x[P++]<<8)+x[P++]}function u(){return(x[P++]<<24)+(x[P++]<<16)+(x[P++]<<8)+x[P++]}function c(e){"undefined"==typeof e&&(e=i());var t=x.slice(P,P+e);return P+=e,t.map(function(e){return String.fromCharCode(e)}).join("")}function d(e){return"undefined"==typeof e&&(e=i()),P+=e,x.slice(P-e,P)}function h(e,t){return t?x.slice(P+e,P+t):x.slice(P+e)}function p(e,t,n){var o=x.length-P;if(t>o){if(n){if(n>P)throw"rQwait cannot backup "+n+" bytes";P-=n}return!0}return!1}function m(){return Base64.encode(T)}function f(e){x=x.concat(Base64.decode(e,0))}function g(){return 0!==F.bufferedAmount&&Util.Debug("bufferedAmount: "+F.bufferedAmount),F.bufferedAmount<D.maxBufferedAmount?(T.length>0&&(F.send(m(T)),T=[]),!0):(Util.Info("Delaying send, bufferedAmount: "+F.bufferedAmount),!1)}function v(e){return T=T.concat(e),g()}function b(e){D.send(e.split("").map(function(e){return e.charCodeAt(0)}))}function y(e){try{f(e.data),i()>0?(B.message(),x.length>k&&(x=x.slice(P),P=0)):Util.Debug("Ignoring empty message")}catch(t){"undefined"!=typeof t.stack?Util.Warn("recv_message, caught exception: "+t.stack):"undefined"!=typeof t.description?Util.Warn("recv_message, caught exception: "+t.description):Util.Warn("recv_message, caught exception:"+t),"undefined"!=typeof t.name?B.error(t.name+": "+t.message):B.error(t)}}function w(e,t){B[e]=t}function A(){x=[],P=0,T=[],F=null}function C(e){A(),F=I?{}:new WebSocket(e,"base64"),F.onmessage=y,F.onopen=function(){Util.Debug(">> WebSock.onopen"),F.protocol&&Util.Info("Server chose sub-protocol: "+F.protocol),B.open(),Util.Debug("<< WebSock.onopen")},F.onclose=function(e){Util.Debug(">> WebSock.onclose"),B.close(e),Util.Debug("<< WebSock.onclose")},F.onerror=function(e){Util.Debug(">> WebSock.onerror: "+e),B.error(e),Util.Debug("<< WebSock.onerror")}}function S(){F&&((F.readyState===WebSocket.OPEN||F.readyState===WebSocket.CONNECTING)&&(Util.Info("Closing WebSocket connection"),F.close()),F.onmessage=function(){})}function _(e){return I=!0,D.send=e,D.close=function(){},y}function E(){return D.maxBufferedAmount=200,D.get_sQ=e,D.get_rQ=t,D.get_rQi=n,D.set_rQi=o,D.rQlen=i,D.rQpeek8=a,D.rQshift8=s,D.rQunshift8=r,D.rQshift16=l,D.rQshift32=u,D.rQshiftStr=c,D.rQshiftBytes=d,D.rQslice=h,D.rQwait=p,D.flush=g,D.send=v,D.send_string=b,D.on=w,D.init=A,D.open=C,D.close=S,D.testMode=_,D}var D={},F=null,x=[],P=0,k=1e4,T=[],B={message:function(){},open:function(){},close:function(){},error:function(){}},I=!1;return E()}window.WebSocket&&!window.WEB_SOCKET_FORCE_FLASH?Websock_native=!0:window.MozWebSocket&&!window.WEB_SOCKET_FORCE_FLASH?(Websock_native=!0,window.WebSocket=window.MozWebSocket):(Websock_native=!1,function(){function e(){return"undefined"!=typeof INCLUDE_URI?INCLUDE_URI:"include/"}var t="<script src='"+e(),n="'></script>",o="";window.WEB_SOCKET_SWF_LOCATION=e()+"web-socket-js/WebSocketMain.swf",Util.Engine.trident&&(Util.Debug("Forcing uncached load of WebSocketMain.swf"),window.WEB_SOCKET_SWF_LOCATION+="?"+Math.random()),o+=t+"web-socket-js/swfobject.js"+n,o+=t+"web-socket-js/web_socket.js"+n,document.write(o)}());