/*
 * noVNC: HTML5 VNC client
 * Copyright (C) 2011 Joel Martin
 * Licensed under LGPL-3 (see LICENSE.txt)
 *
 * See README.md for usage and integration instructions.
 */
function Display(e){"use strict";function t(){Util.Debug(">> Display.constructor");var e,t,n,o,i=Util.Engine;if(!l.target)throw"target must be set";if("string"==typeof l.target)throw"target must be a DOM element";if(e=l.target,!e.getContext)throw"no getContext method";if(u||(u=e.getContext("2d")),Util.Debug("User Agent: "+navigator.userAgent),i.gecko&&Util.Debug("Browser: gecko "+i.gecko),i.webkit&&Util.Debug("Browser: webkit "+i.webkit),i.trident&&Util.Debug("Browser: trident "+i.trident),i.presto&&Util.Debug("Browser: presto "+i.presto),r.clear(),!("createImageData"in u))throw"Canvas does not support createImageData";for(l.render_mode="canvas rendering",null===l.prefer_js&&(Util.Info("Prefering javascript operations"),l.prefer_js=!0),g=u.createImageData(16,16),n=[],t=0;256>t;t+=1)n.push(255);try{o=e.style.cursor,changeCursor(l.target,n,n,2,2,8,8),e.style.cursor?(null===l.cursor_uri&&(l.cursor_uri=!0),Util.Info("Data URI scheme cursor supported")):(null===l.cursor_uri&&(l.cursor_uri=!1),Util.Warn("Data URI scheme cursor not supported")),e.style.cursor=o}catch(a){Util.Error("Data URI scheme cursor test exception: "+a),l.cursor_uri=!1}return Util.Debug("<< Display.constructor"),r}var n,o,i,a,s,r={},l={},u=null,c=0,d=0,h={x:0,y:0,w:0,h:0},p={x1:0,y1:0,x2:-1,y2:-1},m="",f=null,g=null,v=0,b=0;return Util.conf_defaults(l,r,e,[["target","wo","dom",null,"Canvas element for rendering"],["context","ro","raw",null,"Canvas 2D context for rendering (read-only)"],["logo","rw","raw",null,'Logo to display when cleared: {"width": width, "height": height, "data": data}'],["true_color","rw","bool",!0,"Use true-color pixel data"],["colourMap","rw","arr",[],"Colour map array (when not true-color)"],["scale","rw","float",1,"Display area scale factor 0.0 - 1.0"],["viewport","rw","bool",!1,"Use a viewport set with viewportChange()"],["width","rw","int",null,"Display area width"],["height","rw","int",null,"Display area height"],["render_mode","ro","str","","Canvas rendering mode (read-only)"],["prefer_js","rw","str",null,"Prefer Javascript over canvas methods"],["cursor_uri","rw","raw",null,"Can we render cursor using data URI"]]),r.get_context=function(){return u},r.set_scale=function(e){s(e)},r.set_width=function(e){r.resize(e,d)},r.get_width=function(){return c},r.set_height=function(e){r.resize(c,e)},r.get_height=function(){return d},s=function(e){var t,n,o,i,a=["transform","WebkitTransform","MozTransform",null];for(t=l.target,n=a.shift();n&&"undefined"==typeof t.style[n];)n=a.shift();return null===n?(Util.Debug("No scaling support"),void 0):("undefined"==typeof e?e=l.scale:e>1?e=1:.1>e&&(e=.1),l.scale!==e&&(l.scale=e,o=t.width-t.width*e,i=t.height-t.height*e,t.style[n]="scale("+l.scale+") translate(-"+o+"px, -"+i+"px)"),void 0)},a=function(e){var t,n;t=l.true_color?e:l.colourMap[e[0]],n="rgb("+t[2]+","+t[1]+","+t[0]+")",n!==m&&(u.fillStyle=n,m=n)},r.viewportChange=function(e,t,n,o){var i,a,s,r,m,f,g,v=l.target,b=h,y=p,w=null;l.viewport||(Util.Debug("Setting viewport to full display region"),e=-b.w,t=-b.h,n=c,o=d),"undefined"==typeof e&&(e=0),"undefined"==typeof t&&(t=0),"undefined"==typeof n&&(n=b.w),"undefined"==typeof o&&(o=b.h),n>c&&(n=c),o>d&&(o=d),(b.w!==n||b.h!==o)&&(n<b.w&&y.x2>b.x+n-1&&(y.x2=b.x+n-1),b.w=n,o<b.h&&y.y2>b.y+o-1&&(y.y2=b.y+o-1),b.h=o,b.w>0&&b.h>0&&v.width>0&&v.height>0&&(w=u.getImageData(0,0,v.width<b.w?v.width:b.w,v.height<b.h?v.height:b.h)),v.width=b.w,v.height=b.h,w&&u.putImageData(w,0,0)),r=b.x+b.w-1,m=b.y+b.h-1,0>e&&b.x+e<0&&(e=-b.x),r+e>=c&&(e-=r+e-c+1),b.y+t<0&&(t=-b.y),m+t>=d&&(t-=m+t-d+1),(0!==e||0!==t)&&(Util.Debug("viewportChange deltaX: "+e+", deltaY: "+t),b.x+=e,r+=e,b.y+=t,m+=t,b.x>y.x1&&(y.x1=b.x),r<y.x2&&(y.x2=r),b.y>y.y1&&(y.y1=b.y),m<y.y2&&(y.y2=m),0>e?(a=0,f=-e):(a=b.w-e,f=e),0>t?(s=0,g=-t):(s=b.h-t,g=t),i=u.fillStyle,u.fillStyle="rgb(255,255,255)",0!==e&&(u.drawImage(v,0,0,b.w,b.h,-e,0,b.w,b.h),u.fillRect(a,0,f,b.h)),0!==t&&(u.drawImage(v,0,0,b.w,b.h,0,-t,b.w,b.h),u.fillRect(0,s,b.w,g)),u.fillStyle=i)},r.getCleanDirtyReset=function(){var e,t=h,n=p,o=[],i=t.x+t.w-1,a=t.y+t.h-1;return e={x:n.x1,y:n.y1,w:n.x2-n.x1+1,h:n.y2-n.y1+1},n.x1>=n.x2||n.y1>=n.y2?o.push({x:t.x,y:t.y,w:t.w,h:t.h}):(t.x<n.x1&&o.push({x:t.x,y:t.y,w:n.x1-t.x+1,h:t.h}),i>n.x2&&o.push({x:n.x2+1,y:t.y,w:i-n.x2,h:t.h}),t.y<n.y1&&o.push({x:n.x1,y:t.y,w:n.x2-n.x1+1,h:n.y1-t.y}),a>n.y2&&o.push({x:n.x1,y:n.y2+1,w:n.x2-n.x1+1,h:a-n.y2})),p={x1:t.x,y1:t.y,x2:t.x+t.w-1,y2:t.y+t.h-1},{cleanBox:e,dirtyBoxes:o}},r.absX=function(e){return e+h.x},r.absY=function(e){return e+h.y},r.resize=function(e,t){m="",c=e,d=t,s(l.scale),r.viewportChange()},r.clear=function(){l.logo?(r.resize(l.logo.width,l.logo.height),r.blitStringImage(l.logo.data,0,0)):(r.resize(640,20),u.clearRect(0,0,h.w,h.h))},r.fillRect=function(e,t,n,o,i){a(i),u.fillRect(e-h.x,t-h.y,n,o)},r.copyImage=function(e,t,n,o,i,a){var s=e-h.x,r=t-h.y,c=n-h.x,d=o-h.y;u.drawImage(l.target,s,r,i,a,c,d,i,a)},r.startTile=function(e,t,n,o,i){var a,s,c,d,h,p;if(v=e,b=t,f=16===n&&16===o?g:u.createImageData(n,o),a=f.data,l.prefer_js)for(s=l.true_color?i:l.colourMap[i[0]],c=s[2],d=s[1],h=s[0],p=0;4*n*o>p;p+=4)a[p]=c,a[p+1]=d,a[p+2]=h,a[p+3]=255;else r.fillRect(e,t,n,o,i)},r.subTile=function(e,t,n,o,i){var a,s,u,c,d,h,p,m,g,y,w;if(l.prefer_js)for(a=f.data,p=f.width,u=l.true_color?i:l.colourMap[i[0]],c=u[2],d=u[1],h=u[0],y=e+n,w=t+o,m=t;w>m;m+=1)for(g=e;y>g;g+=1)s=4*(g+m*p),a[s]=c,a[s+1]=d,a[s+2]=h,a[s+3]=255;else r.fillRect(v+e,b+t,n,o,i)},r.finishTile=function(){l.prefer_js&&u.putImageData(f,v-h.x,b-h.y)},n=function(e,t,n,o,i,a){var s,r,l,c,d=h;for(s=u.createImageData(n,o),c=s.data,r=0,l=a;4*n*o>r;r+=4,l+=3)c[r]=i[l],c[r+1]=i[l+1],c[r+2]=i[l+2],c[r+3]=255;u.putImageData(s,e-d.x,t-d.y)},o=function(e,t,n,o,i,a){var s,r,l,c,d=h;for(s=u.createImageData(n,o),c=s.data,r=0,l=a;4*n*o>r;r+=4,l+=4)c[r]=i[l+2],c[r+1]=i[l+1],c[r+2]=i[l],c[r+3]=255;u.putImageData(s,e-d.x,t-d.y)},i=function(e,t,n,o,i,a){var s,r,c,d,p,m;for(s=u.createImageData(n,o),d=s.data,m=l.colourMap,r=0,c=a;4*n*o>r;r+=4,c+=1)p=m[i[c]],d[r]=p[2],d[r+1]=p[1],d[r+2]=p[0],d[r+3]=255;u.putImageData(s,e-h.x,t-h.y)},r.blitImage=function(e,t,n,a,s,r){l.true_color?o(e,t,n,a,s,r):i(e,t,n,a,s,r)},r.blitRgbImage=function(e,t,o,a,s,r){l.true_color?n(e,t,o,a,s,r):i(e,t,o,a,s,r)},r.blitStringImage=function(e,t,n){var o=new Image;o.onload=function(){u.drawImage(o,t-h.x,n-h.y)},o.src=e},r.changeCursor=function(e,t,n,o,i,a){return l.cursor_uri===!1?(Util.Warn("changeCursor called but no cursor data URI support"),void 0):(l.true_color?changeCursor(l.target,e,t,n,o,i,a):changeCursor(l.target,e,t,n,o,i,a,l.colourMap),void 0)},r.defaultCursor=function(){l.target.style.cursor="default"},t()}function changeCursor(e,t,n,o,i,a,s,r){"use strict";var l,u,c,d,h,p,m,f,g,v,b=[];for(b.push16le=function(e){this.push(255&e,255&e>>8)},b.push32le=function(e){this.push(255&e,255&e>>8,255&e>>16,255&e>>24)},u=40,c=4*a*s,h=Math.ceil(a*s/8),d=Math.ceil(a*s/8),b.push16le(0),b.push16le(2),b.push16le(1),b.push(a),b.push(s),b.push(0),b.push(0),b.push16le(o),b.push16le(i),b.push32le(u+c+h+d),b.push32le(22),b.push32le(u),b.push32le(a),b.push32le(2*s),b.push16le(1),b.push16le(32),b.push32le(0),b.push32le(h+d),b.push32le(0),b.push32le(0),b.push32le(0),b.push32le(0),v=s-1;v>=0;v-=1)for(g=0;a>g;g+=1)m=v*Math.ceil(a/8)+Math.floor(g/8),f=128&n[m]<<g%8?255:0,r?(m=a*v+g,l=r[t[m]],b.push(l[2]),b.push(l[1]),b.push(l[0]),b.push(f)):(m=4*(a*v+g),b.push(t[m+2]),b.push(t[m+1]),b.push(t[m]),b.push(f));for(v=0;s>v;v+=1)for(g=0;g<Math.ceil(a/8);g+=1)b.push(0);for(v=0;s>v;v+=1)for(g=0;g<Math.ceil(a/8);g+=1)b.push(0);p="data:image/x-icon;base64,"+Base64.encode(b),e.style.cursor="url("+p+") "+o+" "+i+", default"}